from odoo import models, fields, api, _

class Testmodel(models.Model):

    _name = 'testmodel' # creation table with name testmodel
    _description = 'test module for my demo pj'

    name = fields.Char()
    name_company = fields.Char(translate=True, required=True)
    model_of_mobile = fields.Char(translate=True, required=True)  # creation on server odoo that we need to creat table with name testmodel, with 2 fields
    description = fields.Char()  # y have to open terminal and always use this command when y adding a new module in your own repositories "odoo-helper-link"
    date_b = fields.Datetime(required=True)
    serial_number = fields.Char()
    date = fields.Date()
    amount = fields.Integer()
    price = fields.Char()
    manufacturer = fields.Selection(selection=[('america', 'America'), ('china', 'China')])  # saving in format like "test", will be displayed like "Test"
    # Boolean = fields.Boolean()
    # Text = fields.Text(required=True)
    txthtmlformat = fields.Html()
    Bin = fields.Binary()
   
    dm2link = fields.One2many('nvfm', 'nvfmplustm1')
    testm2m = fields.Many2one('nvfm')
    pj2m2s = fields.Many2many('nvfm')

    n1 = fields.Integer()
    n2 = fields.Integer()
    n3 = fields.Integer(compute='_compute_n3')
    count_lines_dm2link = fields.Integer(compute='_compute_count_lines_dm2link')
    sometext = fields.Char(compute='_compute_n3')

    @api.depends('n1', 'n2')
    def _compute_n3(self):
        for rec in self:
            rec.n3 = rec.n2 + rec.n1
            rec.sometext ='%s, %s' % (rec.n2, rec.n1)

    @api.depends('dm2link')
    def _compute_count_lines_dm2link(self):
        for rec in self:
            rec.count_lines_dm2link = len(rec.dm2link)

    def action_get_counts(self):
        self.ensure_one()
        action = self.env.ref('testmodule.nvfm_action').sudo()
        action = action.read()[0]
        action['domain'] = [('testm_ids.id', '=', self.id)]

        return action

